#ifndef EVAS_CANVAS3D_CAMERA_EO_HH
#define EVAS_CANVAS3D_CAMERA_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "evas_canvas3d_camera.eo.h"
#include "evas_canvas3d_node.eo.h"
#include "evas_canvas3d_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#include "evas_canvas3d_node.eo.hh"
#include "evas_canvas3d_object.eo.hh"
#ifndef EVAS_CANVAS3D_CAMERA_FWD_GUARD
#define EVAS_CANVAS3D_CAMERA_FWD_GUARD
namespace evas { namespace canvas3d { 
struct Camera;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Camera> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Camera&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Camera const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Camera const&> : ::std::true_type {}; } }
#endif
#ifndef EVAS_CANVAS3D_NODE_FWD_GUARD
#define EVAS_CANVAS3D_NODE_FWD_GUARD
namespace evas { namespace canvas3d { 
struct Node;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Node> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Node&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Node const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Node const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_OBJECT_FWD_GUARD
#define EFL_OBJECT_FWD_GUARD
namespace efl { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const&> : ::std::true_type {}; } }
#endif
#ifndef EVAS_CANVAS3D_OBJECT_FWD_GUARD
#define EVAS_CANVAS3D_OBJECT_FWD_GUARD
namespace evas { namespace canvas3d { 
struct Object;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Object> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Object&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Object const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::evas::canvas3d::Object const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace evas { namespace canvas3d { 
struct Camera {
   ::efl::eolian::return_traits<void>::type projection_matrix_set( ::efl::eolian::in_traits<Evas_Real const&>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_matrix_get( ::efl::eolian::out_traits<Evas_Real>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_perspective_set( ::efl::eolian::in_traits<Evas_Real>::type fovy,  ::efl::eolian::in_traits<Evas_Real>::type aspect,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_frustum_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_ortho_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<bool>::type node_visible_get( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type camera_node,  ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node,  ::efl::eolian::in_traits<Evas_Canvas3D_Frustum_Mode>::type key) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_CAMERA_CLASS;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Camera *>(this))); }
   operator ::evas::canvas3d::Camera() const;
   operator ::evas::canvas3d::Camera&();
   operator ::evas::canvas3d::Camera const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Camera,  ::efl::Object,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Camera const ,  ::efl::Object const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace evas { namespace canvas3d { 
struct Camera : private ::efl::eo::concrete
   , EO_CXX_INHERIT(::efl::Object)
   , EO_CXX_INHERIT(::evas::canvas3d::Object)
{
   explicit Camera( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Camera(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Camera() = default;
   Camera(Camera const&) = default;
   Camera(Camera&&) = default;
   Camera& operator=(Camera const&) = default;
   Camera& operator=(Camera&&) = default;
   template <typename Derived>
   Camera(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Camera, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   Camera( ::efl::eo::instantiate_t)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   template <typename T>
   explicit Camera( ::efl::eo::instantiate_t, T&& parent, typename std::enable_if< ::efl::eo::is_eolian_object<T>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Camera( ::efl::eo::instantiate_t, F&& f, typename ::std::enable_if< ::efl::eolian::is_constructor_lambda<F, Camera >::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), *this, std::forward<F>(f));
   }
   template <typename T, typename F> Camera(  ::efl::eo::instantiate_t, T&& parent, F&& f, typename ::std::enable_if< ::efl::eolian::is_constructor_lambda<F, Camera >::value && ::efl::eo::is_eolian_object<T>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class(), *this, std::forward<F>(f));
   }

   ::efl::eolian::return_traits<void>::type projection_matrix_set( ::efl::eolian::in_traits<Evas_Real const&>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_matrix_get( ::efl::eolian::out_traits<Evas_Real>::type matrix) const;
   ::efl::eolian::return_traits<void>::type projection_perspective_set( ::efl::eolian::in_traits<Evas_Real>::type fovy,  ::efl::eolian::in_traits<Evas_Real>::type aspect,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_frustum_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<void>::type projection_ortho_set( ::efl::eolian::in_traits<Evas_Real>::type left,  ::efl::eolian::in_traits<Evas_Real>::type right,  ::efl::eolian::in_traits<Evas_Real>::type bottom,  ::efl::eolian::in_traits<Evas_Real>::type top,  ::efl::eolian::in_traits<Evas_Real>::type dnear,  ::efl::eolian::in_traits<Evas_Real>::type dfar) const;
   ::efl::eolian::return_traits<bool>::type node_visible_get( ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type camera_node,  ::efl::eolian::in_traits< ::evas::canvas3d::Node>::type node,  ::efl::eolian::in_traits<Evas_Canvas3D_Frustum_Mode>::type key) const;
   static Efl_Class const* _eo_class()
   {
      return EVAS_CANVAS3D_CAMERA_CLASS;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Camera *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Camera,  ::efl::Object,  ::evas::canvas3d::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Camera const ,  ::efl::Object const ,  ::evas::canvas3d::Object const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Camera> _get_wref() const { return ::efl::eo::wref<Camera>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Camera* operator->() const { return this; }
   Camera* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Camera const& lhs, Camera const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Camera const& lhs, Camera const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Camera) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Camera>::value, "");
} } 
#endif
